#!/usr/bin/python
# -*- coding: utf-8 -*-

# dropbox API-Adustments:
# rest.py:
# ----------------------------------------------------------
# try:
#   from pkg_resources import resource_filename
#   use_pkg_resources = True
# except:
#   use_pkg_resources = False
# def RES(filename):
#    if use_pkg_resources:
#        return resource_filename(__name__, filename)
#    else:
#        if (platform.system() == 'Windows'):
#            return "data/%s" % filename
#        else:
#            return filename
# ----------------------------------------------------------
# TRUSTED_CERT_FILE = RES('trusted-certs.crt')
# ----------------------------------------------------------
# def connect(self):
#     sock = create_connection((self.host, self.port))
#     sock.settimeout(11)
#     ...
# ----------------------------------------------------------


from dropbox import client, rest, session
from dropbox.rest import ErrorResponse, RESTSocketError

import unicodedata as ud

import base64 as _0
import os
import codecs
import platform

from lxml import etree
from lxml.etree import Element
#from xml.etree.ElementTree import Element
#from xml.etree import ElementTree as etree

from time import sleep


def log(text):
    pass
    # print(text)


system = platform.system()
APP_KEY = 'dzI2bzB5cnBqdjFuc2h2'
APP_SEC = 'ZXprZW56bWVnaTlldThw'
ACCESS = 'app_folder'
FILE = 'Clipboard.txt'
XML_HEAD = u'<?xml version="1.0" encoding="UTF-8"?>\n<!DOCTYPE plist PUBLIC "-//Apple//DTD PLIST 1.0//EN" "http://www.apple.com/DTDs/PropertyList-1.0.dtd">\n<plist version="1.0">\n<array>\n'
XML_FOOT = u'</array>\n</plist>\n'
TOKEN_FILE = "token_store.txt"
MAX_ITEMS = 30

_9 = _0.decodestring
_8 = _0.encodestring

DEC = _0.decodestring
ENC = _0.encodestring


def enum(**enums):
    return type('Enum', (), enums)


ST = enum(NEW_DATA=0, CONNECTED=1, NO_INTERNET=2, NOT_AUTHORIZED=3, WAIT_AUTHORIZE=4)


class clipboardData():
    empty_xml = '''<?xml version='1.0' encoding='UTF-8'?>
<plist version="1.0">
		<array>
		</array>
</plist>'''

    def __init__(self, filename):
        log("init clipboardData")
        self.LOCAL_FILE = filename
        try:
            self.readFromDisk()
        except:
            log("error while parsing clipboard file on disk")
            pass
        log("init clipboardData finished.")

    def add(self, str):
        log("Called Add with '%s'" % str)
        if str == None or str.strip() == "":
            log("String is None or empty")
            return False
        else:
            # log("continue ..")
            str = ENC(str.encode("utf-8"))

            if self.elementIsNew(str):
                # print "adding ..."
                p = self.root.find("array")
                e = Element("string")
                e.text = str
                p.insert(0, e)
                log("added string")
                return True
            else:
                log("Element already in the list")
                return False

    def clear(self):
        p = self.root.find("array")
        p.clear()

    def writeToDisk(self):
        self.deleteOverMax()
        self.root.write(self.LOCAL_FILE) #, "utf-8")

    def readFromDisk(self):
        log("READ")
        if not os.access(self.LOCAL_FILE, os.R_OK):
            log("creating new file")
            file = codecs.open(self.LOCAL_FILE, "wb", "utf-8")
            file.write(self.empty_xml)
            file.close()
            log("WRITTEN NEW")
        log("READ NOW")
        try:
            self.root = etree.parse(self.LOCAL_FILE)
        except etree.ParseError as e:
            # elg = e.error_log.filter_from_level(etree.ErrorLevels.FATAL)
            print("XML Error: %s" % e.message)

        except Exception as e:
            log("Error no. %s while parsing at position: %s" % (e.code, e.position))

    def deleteOverMax(self):
        try:
            count = 0
            for x in self.root.getroot():
                for y in x:
                    count += 1
                    if count > MAX_ITEMS:
                        x.remove(y)
        except Exception as e:
            print("Error in deleteOverMax: " + e.message)


    def getClipboardStringList(self):
        self.deleteOverMax()
        list = []
        removelist = []
        try:
            p = self.root.find("array")
            count = 0
            for i in p:
                count += 1
                if count > MAX_ITEMS:
                    removelist.append(i);
                else:
                    try:
                        list.append(DEC(i.text).decode("utf-8"))
                    except:
                        print "Error: No Base64 encoded string"
                        list.append("Update all clients of omnicopy!")

        except Exception as e:
            print "Error getClipboardStringList: " + e.message

        return list

    def elementIsNew(self, str):
        p = self.root.find("array")
        for i in p:
            if DEC(i.text.rstrip()) == DEC(str.rstrip()):
                return False

        return True

    def dump(self):
        dump(self.root)
        p = self.root.find("array")
        for i in p:
            print "----------------------------------------------------------"
            print i.text
        print "----------------------------------------------------------"


class OmniCopyAPI():
    def __init__(self):
        self.sess = StoredSession(_9(APP_KEY), _9(APP_SEC), ACCESS)
        self.client = client.DropboxClient(self.sess)
        self.list = list()
        appData = self.getLocalAppDataFolder()
        self.LOCAL_FILE = appData + FILE
        self.TOKEN_STORE = appData + TOKEN_FILE
        self.revision = -1
        self.status = ST.NOT_AUTHORIZED
        self.rev = None
        self.array = clipboardData(self.LOCAL_FILE)
        self.uploadLock = False
        self.clearList = False
        log("Local storage in: '" + appData + "'")

    def addNewEntry(self, entry):
        if not self.array.add(entry): return False
        log("Add New Called")
        self.checkCloud()
        while not self.uploadClipboard() == True:
            self.checkCloud()
            if not self.array.add(entry): return False
        return True

    def uploadClipboard(self, overwrite=False):

        log("upload called ...")
        while self.uploadLock:
            log("wait for lock release1 ...")
            sleep(0.10)

        while self.uploadLock:
            log("wait for lock release2 ...")
            sleep(0.10)

        self.uploadLock = True

        try:
            self.array.writeToDisk()

            f = open(self.LOCAL_FILE, "rb")
            if overwrite:
                metadata = self.client.put_file(FILE, f, True)
            else:
                metadata = self.client.put_file(FILE, f, False, self.rev)

            if self.noConflicts(metadata):
                log('Successful upload');
                self.revision = metadata["revision"]
                self.rev = metadata["rev"]
                self.uploadLock = False
                return True
            else:
                log('Upload of conflicted copy');

        except Exception, e:
            log('error: %s' % e)
            self.handleException(e)

        self.uploadLock = False
        return False

    def noConflicts(self, metadata):
        return metadata['path'] == "/%s" % FILE

    def checkCloud(self):
        if self.clearList:
            return self.doClear()
        try:
            metadata = self.client.metadata(FILE)
            revision = metadata["revision"]
            log("Check: old %d new %d" % (self.revision, revision))
            if self.revision != revision:
                self.status = ST.NEW_DATA
                if not self.downloadClipboard():
                    self.downloadClipboard()
            else:
                self.status = ST.CONNECTED
            return self.revision
        except Exception, e:
            self.handleException(e)
            log("exception occured checkCloud")
            return -1

    def handleException(self, e):
        try:
            if type(e) is RESTSocketError:
                log("HANDLE RESTSocketError. %s" % e)
                self.status = ST.NO_INTERNET

            elif type(e) is ErrorResponse:
                print("HANDLE ErrorResponse %d" % e.status)
                ec = e.status
                if ec == 400:  # Bad input parameter. Error message should indicate which one and why.
                    pass
                elif ec == 401:  # Bad or expired token. This can happen if the user or Dropbox revoked or expired an access token. To fix, you should re-authenticate the user.
                    self.unlink()

                elif ec == 403:  # Bad OAuth request (wrong consumer key, bad nonce, expired timestamp...). Unfortunately, re-authenticating the user won't help here.
                    self.status = ST.NOT_AUTHORIZED

                elif ec == 404:  # File or folder not found at the specified path.
                    # file was not found ... bootstrap by uploading new file
                    self.uploadClipboard(True)

                elif ec == 405:  # Request method not expected (generally should be GET or POST).
                    pass

                elif ec == 503:  # Your app is making too many requests and is being rate limited. 503s can trigger on a per-app or per-user basis.
                    pass

                elif ec == 507:  # User is over Dropbox storage quota.
                    pass

                elif ec > 500:  # Server error. Check our ops Twitter feed @DropboxOps.
                    pass
        except:
            log("Error in exception handling")

    def downloadClipboard(self):
        # Download file via API
        try:
            f, metadata = self.client.get_file_and_metadata(FILE)
            data = f.read()
            f.close()
            out = codecs.open(self.LOCAL_FILE, 'wb');
            out.write(data)
            out.close()

            try:
                self.xmlParse(self.LOCAL_FILE)
            except Exception as e:
                print "Exception Parsing local file:  %s" % e
                quit(1)
                log("Error Parsing file. Clearing for recovery.")
                # self.uploadClipboard(True)
                return False
            self.revision = metadata["revision"]
            self.rev = metadata["rev"]
            if self.noConflicts(metadata):
                log('Successful download');
            else:
                log('Download of conflicted copy');

            log("Downloaded new Clipboard '%s' rev %d" % (metadata['path'], self.revision))
            return True
            # self.readNewClipboard()
        except Exception, e:
            self.handleException(e)
            return False

    def getClipboard(self):
        return self.array.getClipboardStringList()

    def link(self):
        try:
            if self.sess.load_creds(self.TOKEN_STORE):
                self.status = ST.CONNECTED
                return True
            else:
                url = self.sess.getRequestURL()
                self.status = ST.WAIT_AUTHORIZE
                return url
        except Exception, e:
            self.handleException(e)

    def unlink(self):
        self.sess.unlink()
        self.status = ST.NOT_AUTHORIZED
        self.revision = -1
        self.rev = -1

    def clear(self):
        self.clearList = True

    def doClear(self):
        self.clearList = False
        # make sure, we are on the current version
        self.checkCloud()
        # clear and
        self.array.clear()
        while not self.uploadClipboard() == True:
            log("try again")
            self.checkCloud()

        # download again
        return self.checkCloud()

    def tryAuth(self):
        return self.sess.tryAuth()

    def currentStatus(self):
        return self.status

    def getLocalAppDataFolder(self):
        log("System: " + system)
        if system == "Windows":
            homedir = os.environ['APPDATA']
            homedir += "\\OmniCopy\\"
        elif system == "Darwin":
            homedir = os.path.expanduser("~");
            homedir += "/Library/Application Support/OmniCopy/";
        else:
            homedir = os.path.expanduser("~")
            homedir += "/.config/OmniCopy/"

        if not os.path.exists(homedir):
            os.makedirs(homedir)
        return homedir

    def xmlShowNode(self, node):
        if node.nodeType == Node.ELEMENT_NODE:
            log('Element name: %s' % node.nodeName)
            for (name, value) in node.attributes.items():
                log('    Attr -- Name: %s  Value: %s' % (name, value))
            if node.attributes.get('ID') is not None:
                log('    ID: %s' % node.attributes.get('ID').value)
            for child in node.childNodes:
                self.xmlShowNode(child)

    def getStringListFromXML(self, node):
        i = 0
        for child in node:
            if child.firstChild != None:
                i += 1
                if (i >= MAX_ITEMS):
                    return
                self.list.append(unicode(self.decode(child.firstChild.data)).decode("utf-8"))

    def xmlParse(self, xml):
        self.array.readFromDisk()


class StoredSession(session.DropboxSession):
    """a wrapper around DropboxSession that stores a token to a file on disk"""

    def load_creds(self, tokenFile):
        self.tokenFile = tokenFile
        try:
            stored_creds = open(self.tokenFile).read()
            stored_creds = _9(stored_creds)
            self.set_token(*stored_creds.split('|'))
            log("[loaded access token]")
            return True
        except:
            pass  # don't worry if it's not there
        log("[could not load token]")
        return False

    def write_creds(self, token):
        f = open(self.tokenFile, 'w')
        tok = "|".join([token.key, token.secret])
        f.write(_8(tok))
        f.close()

    def delete_creds(self):
        try:
            os.unlink(self.tokenFile)
        except:
            log("[Token file already deleted]")

    def getRequestURL(self):
        self.request_token = self.obtain_request_token()
        url = self.build_authorize_url(self.request_token)
        return url

    def tryAuth(self):
        try:
            if self.request_token != None:
                self.obtain_access_token(self.request_token)
                self.write_creds(self.token)
                self.status = ST.CONNECTED
                return True
        except Exception, e:
            pass
        return False

    def unlink(self):
        self.delete_creds()
        session.DropboxSession.unlink(self)
        self.status = ST.NOT_AUTHORIZED
